/*
 * Copyright (c) 2022, MediaTek Inc. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef _SPM_MTCMOS_
#define _SPM_MTCMOS_

#define STA_POWER_DOWN  0
#define STA_POWER_ON    1

enum power_domain_id {
	MT8188_POWER_DOMAIN_MFG0,
	MT8188_POWER_DOMAIN_MFG1,
	MT8188_POWER_DOMAIN_MFG2,
	MT8188_POWER_DOMAIN_MFG3,
	MT8188_POWER_DOMAIN_MFG4,
	MT8188_POWER_DOMAIN_PEXTP_MAC_P0,
	MT8188_POWER_DOMAIN_PEXTP_PHY_TOP,
	MT8188_POWER_DOMAIN_CSIRX_TOP,
	MT8188_POWER_DOMAIN_ETHER,
	MT8188_POWER_DOMAIN_HDMI_TX,
	MT8188_POWER_DOMAIN_ADSP_AO,
	MT8188_POWER_DOMAIN_ADSP_INFRA,
	MT8188_POWER_DOMAIN_ADSP,
	MT8188_POWER_DOMAIN_AUDIO,
	MT8188_POWER_DOMAIN_AUDIO_ASRC,
	MT8188_POWER_DOMAIN_VPPSYS0,
	MT8188_POWER_DOMAIN_VDOSYS0,
	MT8188_POWER_DOMAIN_VDOSYS1,
	MT8188_POWER_DOMAIN_DP_TX,
	MT8188_POWER_DOMAIN_EDP_TX,
	MT8188_POWER_DOMAIN_VPPSYS1,
	MT8188_POWER_DOMAIN_WPE,
	MT8188_POWER_DOMAIN_VDEC0,
	MT8188_POWER_DOMAIN_VDEC1,
	MT8188_POWER_DOMAIN_VENC,
	MT8188_POWER_DOMAIN_IMG_VCORE,
	MT8188_POWER_DOMAIN_IMG_MAIN,
	MT8188_POWER_DOMAIN_DIP,
	MT8188_POWER_DOMAIN_IPE,
	MT8188_POWER_DOMAIN_CAM_VCORE,
	MT8188_POWER_DOMAIN_CAM_MAIN,
	MT8188_POWER_DOMAIN_CAM_SUBA,
	MT8188_POWER_DOMAIN_CAM_SUBB,
	MT8188_POWER_DOMAIN_NR,
};

void spm_mtcmos_on(enum power_domain_id ID);
void spm_mtcmos_off(enum power_domain_id ID);
void spm_mtcmos_on_all(void);

#endif
